]> git.pld-linux.org Git - packages/apache1.git/blobdiff - apache1.init
- release 6
[packages/apache1.git] / apache1.init
index ffa6e3dcf3f9c6d8dbd1e6560e7ceba0950821ef..e050eb2835a7eaaba3c615b2f5381896a1a545a1 100644 (file)
@@ -22,7 +22,7 @@
 # Check that networking is up.
 if is_yes "${NETWORKING}"; then
        if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status ]; then
-               msg_network_down apache
+               msg_network_down "Apache 1.3 Web Server"
                exit 1
        fi
 else
@@ -34,51 +34,110 @@ if is_no "${IPV6_NETWORKING}"; then
 fi
 
 configtest() {
-       apache -t > /dev/null 2>&1
+       /usr/sbin/apache -t
+}
+
+# wrapper for configtest
+checkconfig() {
+       local details=${1:-0}
+
+       if [ $details = 1 ]; then
+               # run config test and display report (status action)
+               show "Checking %s configuration" "Apache 1.3 Web Server"; busy
+               local out
+               out=`configtest 2>&1`
+               RETVAL=$?
+               if [ $RETVAL = 0 ]; then
+                       ok
+               else
+                       fail
+               fi
+               [ "$out" ] && echo >&2 "$out"
+       else
+               # run config test and abort with nice message if failed
+               # (for actions checking status before action).
+               configtest >/dev/null 2>&1
+               RETVAL=$?
+               if [ $RETVAL != 0 ]; then
+                       show "Checking %s configuration" "Apache 1.3 Web Server"; fail
+                       nls 'Configuration test failed. See details with %s "checkconfig"' $0
+                       exit $RETVAL
+               fi
+       fi
 }
 
 start() {
        # Check if the service is already running?
        if [ -x /usr/lib/apache1/lingerd ]; then
                if [ ! -f /var/lock/subsys/lingerd ]; then
-                       msg_starting lingerd
+                       msg_starting "Apache Lingerd"
                        SERVICE_UMASK=002 daemon --user http /usr/lib/apache1/lingerd
                        RETVAL=$?
                        [ $RETVAL -eq 0 ] && touch /var/lock/subsys/lingerd
                else
-                       msg_already_running lingerd
+                       msg_already_running "Apache Lingerd"
                fi
        fi
-       if [ ! -f /var/lock/subsys/apache ]; then
-               msg_starting apache
-               daemon apache $HTTPD_OPTS
-               RETVAL=$?
-               [ $RETVAL -eq 0 ] && touch /var/lock/subsys/apache
-       else
-               msg_already_running apache
+
+       if [ -f /var/lock/subsys/apache ]; then
+               msg_already_running "Apache 1.3 Web Server"
+               return
        fi
+
+       checkconfig
+       msg_starting "Apache 1.3 Web Server"
+       daemon /usr/sbin/apache $HTTPD_OPTS
+       RETVAL=$?
+       [ $RETVAL -eq 0 ] && touch /var/lock/subsys/apache
 }
 
 stop() {
        # Stop daemons.
        if [ -f /var/lock/subsys/apache ]; then
-               msg_stopping apache
-               killproc apache
+               msg_stopping "Apache 1.3 Web Server"
+               killproc --pidfile /var/run/apache.pid apache
                rm -f /var/lock/subsys/apache /var/run/apache.pid /var/run/apache.loc* >/dev/null 2>&1
        else
-               msg_not_running apache
+               msg_not_running "Apache 1.3 Web Server"
        fi
        if [ -x /usr/lib/apache1/lingerd ]; then
                if [ -f /var/lock/subsys/lingerd ]; then
-                       msg_stopping lingerd
+                       msg_stopping "Apache Lingerd"
                        /usr/lib/apache1/lingerd -k && ok || fail
                        rm -f /var/lock/subsys/lingerd >/dev/null 2>&1
                else
-                       msg_not_running lingerd
+                       msg_not_running "Apache Lingerd"
                fi
        fi
 }
 
+reload() {
+       local sig=${1:-HUP}
+       local retnr=${2:-7}
+       if [ ! -f /var/lock/subsys/apache ]; then
+               msg_not_running "Apache 1.3 Web Server"
+               RETVAL=$retnr
+               return
+       fi
+
+       checkconfig
+       msg_reloading "Apache 1.3 Web Server"
+       killproc --pidfile /var/run/apache.pid apache -$sig
+       RETVAL=$?
+}
+
+condrestart() {
+       if [ ! -f /var/lock/subsys/apache ]; then
+               msg_not_running "Apache 1.3 Web Server"
+               RETVAL=$1
+               return
+       fi
+
+       checkconfig
+       stop
+       start
+}
+
 RETVAL=0
 # See how we were called.
 case "$1" in
@@ -88,77 +147,33 @@ case "$1" in
   stop)
        stop
        ;;
-  status)
-       status apache
-       RETVAL=$?
-       /usr/sbin/apache -S
-       ;;
   restart)
-       apache -t > /dev/null 2>&1
-       RETVAL=$?
-       if [ $RETVAL -eq 0 ]; then
-               stop
-               start
-       else
-               fail
-               echo "Configuration file syntax test failed."
-       fi
-
+       checkconfig
+       stop
+       start
        ;;
-  force-reload)
-       if [ -f /var/lock/subsys/apache ]; then
-               msg_reloading apache
-
-               configtest
-               RETVAL=$?
-               if [ $RETVAL -eq 0 ]; then
-                       killproc apache -HUP
-               else
-                       fail
-                       echo "Configuration file syntax test failed."
-               fi
-       else
-               msg_not_running apache
-               RETVAL=7
-       fi
+  try-restart)
+       condrestart 0
        ;;
   reload|graceful)
-       if [ -f /var/lock/subsys/apache ]; then
-               msg_reloading apache
-
-               configtest
-               RETVAL=$?
-               if [ $RETVAL -eq 0 ]; then
-                       killproc apache -USR1
-               else
-                       fail
-                       echo >&2 "Configuration file syntax test failed."
-               fi
-       else
-               msg_not_running apache
-               RETVAL=7
-       fi
+       reload USR1 7
+       ;;
+  force-reload)
+       reload HUP 7
        ;;
   flush-logs)
-       if [ -f /var/lock/subsys/apache ]; then
-               msg_reloading apache
-
-               configtest
-               RETVAL=$?
-               if [ $RETVAL -eq 0 ]; then
-                       killproc apache -HUP
-                       RETVAL=$?
-               else
-                       fail
-                       echo >&2 "Configuration file syntax test failed."
-               fi
-       fi
+       reload USR1 0
+       ;;
+  checkconfig|configtest)
+       checkconfig 1
        ;;
-  configtest)
-       apache -t
+  status)
+       status apache
+       RETVAL=$?
+       /usr/sbin/apache -S
        ;;
   *)
-       msg_usage "$0 {start|stop|restart|reload|force-reload|graceful|configtest|status}"
+       msg_usage "$0 {start|stop|restart|try-restart|reload|graceful|force-reload|checkconfig|status}"
        exit 3
        ;;
 esac
This page took 0.035715 seconds and 4 git commands to generate.